#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <conio.h>

#include  "dblib.h"

static char copyright1[] = "(C)Board of Trustees of the University of Illinois, 1992";
static char copyright2[] = "Program conceived by Jeremy Atack and Fred Bateman";
static char copyright3[] = "Developed by Mary Eschelbach Gregson";
static char copyright4[] = "Programmed by Timothy Gregson";
static char copyright5[] = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066";

char  outname[256];
char  drive[3];
char  dir[81];
char  fname[9];
char  ext[4];

void  main (int argc, char **argv)
{
  //  DB  *dbin, *dbout;
  int             dbin, dbout;
  struct  fldinfo info;
  int             newfld;
  int             ercd;
  char            ch;
  char            fldname[11];

  dbinit ();
  if (argc < 5 || argc > 6)
  {
    fprintf (stderr, "Usage: addfld filename fldname fldtype fldlength <flddec>\n");
    exit (0);
  }
  if ((dbin = dbopen (argv[1], 0)) < 0)
  {
    fprintf (stderr, "Couldn't open input dBase file: %s\n", argv[1]);
    exit (1);
  }
  _fullpath(outname, argv[1], 81);
  _splitpath (outname, drive, dir, fname, ext);
  _makepath (outname, drive, dir, "addfld", "tmp");
  if ((dbout = dbnew (outname)) < 0)
  {
    fprintf (stderr, "Couldn't open tempory file: %s\n", outname);
    exit (2);
  }
  dballowdel (dbin, 1);                 // allow deleted records
  info.type = (char)toupper (*argv[3]);
  info.length = atoi (argv[4]);
  if (argc == 6)
    info.decimals = atoi(argv[5]);
  else
    info.decimals = 0;
  dbcopyall (dbout, dbin);
  strcpy (fldname, argv[2]);
  if ((newfld = dbgetfnum(dbin, fldname)) != 0)
  {
    printf ("Field alread exists: %s\n", fldname);
    printf ("Enter [R] to reset field contents or [N] for new field name\n");
    do
    {
      ch = (char)getch ();
      ch = (char)toupper(ch);
    }
    while (ch != 'R' && ch != 'N');
    if (ch == 'N')
    {
      do
      {
        printf ("Enter new field name: ");
        gets(fldname);
        newfld = dbgetfnum(dbin, fldname);
      } while (newfld != 0);
    }
  }
  if (ch != 'R')
  {
    memset (info.name, ' ', 10);
    memcpy (info.name, fldname, strlen (fldname));
    newfld = dbaddfld (dbout, &info);
  }
  ercd = dbread (dbin);
  do
  {
    dbsetdelflag (dbout, dbgetdelflag (dbin));
    if (info.type == 'F' || info.type == 'N')
      ercd = dbputfld (dbout, newfld, "0");
    else
      ercd = dbputfld (dbout, newfld, " ");
    dbwrite (dbout);
  } while ((ercd = dbread(dbin)) == 0);
  dbclose (dbin);
  dbclose (dbout);
  remove (argv[1]);
  rename (outname, argv[1]);
}
