#include  "dblib.hxx"

static char copyright1[] = "This module is copyright Timothy Gregson, 1992";
static char copyright2[] = "It can be used only with the PC Matchmaker record linkage system";
static char copyright3[] = "All other use is prohibited, without written consent of copyright holder";

static  struct  dbfile  files[MAX_DB_NUM];    // array of file pointers
static  char            str[255];
static  char            str1[255];

//    user callable routines

int   dbinit (void)
{
  int   i;

  for (i = 0; i < MAX_DB_NUM; i++)
    memset (&files[i], 0x0, sizeof (struct dbfile));  // init structures
  return (0);
}

int   dbopen (char *filename, int mode)
{
  int   dbhand;
  int   i;

  for (dbhand = 0;files[dbhand].doshandle != 0 && dbhand < MAX_DB_NUM;dbhand++)
  {
    // empty loop
  }
  if (dbhand == MAX_DB_NUM)
    return (-1);
  if ((files[dbhand].doshandle = dos_open (filename, 0)) == 0)
    return (-2);
  dos_read (files[dbhand].doshandle, &files[dbhand].header, sizeof (struct headrec));
  files[dbhand].numflds = (files[dbhand].header.hdlen - 33)/32;
  if ((files[dbhand].flds = mymalloc (files[dbhand].numflds * sizeof (struct dbflds))) == NULL)
    return (-3);
  for (i = 0; i < (int)files[dbhand].numflds; i++)
  {
    dos_read (files[dbhand].doshandle, &files[dbhand].flds[i].dbf, sizeof (struct flddes));
    files[dbhand].flds[i].copyflag = 0;
    files[dbhand].flds[i].data = mymalloc (files[dbhand].flds[i].dbf.length);
  }
  dos_read (files[dbhand].doshandle, &i, sizeof (char));    // eat leftover byte
  if (mode == 1)
    files[dbhand].out = 3;
  return (dbhand);
}

int   dballowdel (int dbhand, int flag)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  files[dbhand].allowdel = (char)flag;
  return (0);
}

int   dbgetdelflag (int dbhand)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (-1);
  if (files[dbhand].doshandle == 0)
    return (-1);
  return (files[dbhand].deleteflag);
}

int dbsetdelflag (int dbhand, int flag)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  files[dbhand].deleteflag = (char)flag;
}
int   dbgetinfo (int dbhand, struct file_info *finfo)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  finfo->nrecs = files[dbhand].header.nrecs;
  finfo->reclen = (long)files[dbhand].header.reclen;
  finfo->numflds = (long)files[dbhand].numflds;
  finfo->out = (int)files[dbhand].out;
  return (0);
}

long  dbgetrecnum (int dbhand)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (0);
  return (files[dbhand].recnum);
}

int   dbread (int dbhand)
{
  int   i;
  char  deleted;

  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  if (files[dbhand].recnum > files[dbhand].header.nrecs)
    return (2);
  do
  {
    if (dos_read (files[dbhand].doshandle, &deleted, sizeof (char)) == 0)
      return (2);
    if (deleted == 0x1a)        // look for a control-Z at eof
      return (2);
    for (i = 0; i < (int)files[dbhand].numflds; i++)
    {
      dos_read (files[dbhand].doshandle, files[dbhand].flds[i].data, files[dbhand].flds[i].dbf.length);
    }
    files[dbhand].recnum++;
  } while (!files[dbhand].allowdel && deleted == '*');
  files[dbhand].deleteflag = (char)(deleted == '*' ? 1 : 0);
  return (0);
}

int   dbpos  (int dbhand, long recnum)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  if (recnum > files[dbhand].header.nrecs + 1)
    return (2);
  if (recnum - 1 == files[dbhand].recnum)
    return (0);
  if (recnum == 0)
    return (3);
  dos_pos (files[dbhand].doshandle, ((recnum - 1) * files[dbhand].header.reclen) + files[dbhand].header.hdlen);
  files[dbhand].recnum = recnum - 1;
  return (0);
}

long  dbfind (int dbhand, int fldnum, char *fld)
{
  int           found = 0;

  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (0L);
  if (files[dbhand].doshandle == 0)
    return (0L);
  dbpos (dbhand, 1L);                     // start search at beginning of file
  strcpy (str1, fld);
  trim (str1);
  strupr (str1);
  while (!found && dbread(dbhand) == 0)
  {
    dbgetfld (dbhand, fldnum, str);
    trim (str);
    if (strcmp(str, str1) == 0)
      found++;
  }
  if (found)
    return (files[dbhand].recnum);
  else
    return (0L);
}

int   dbgetfnum (int dbhand, char *fld)
{
  int   i;

  strcpy (str, fld);
  strupr (str);
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (0L);
  if (files[dbhand].doshandle == 0)
    return (0L);
  for (i = 0; i < (int)files[dbhand].numflds; i++)
  {
    if (strcmp (files[dbhand].flds[i].dbf.fname, str) == 0)
      return (i + 1);
  }
  return (0);
}

int   dbgetfld (int dbhand, int fldnum, char *buf)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  if (fldnum > (int)files[dbhand].numflds)
    return (2);
  memcpy (buf, files[dbhand].flds[fldnum - 1].data, files[dbhand].flds[fldnum - 1].dbf.length);
  buf[files[dbhand].flds[fldnum - 1].dbf.length] = 0;
  return (0);
}

int   dbgetfldinfo (int dbhand, int fldnum, struct fldinfo *info)
{
  char  *ptr;
  int   i;

  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  if (fldnum > (int)files[dbhand].numflds)
    return (2);
  memset (info->name, ' ', 10);       // init field name var to spaces
  for (ptr = files[dbhand].flds[fldnum - 1].dbf.fname, i = 0; *ptr != 0; ptr++, i++)
    info->name[i] = *ptr;             // fill in field name var
  info->type = files[dbhand].flds[fldnum - 1].dbf.ftype;
  info->length = (int)files[dbhand].flds[fldnum - 1].dbf.length;
  info->decimals = (int)files[dbhand].flds[fldnum - 1].dbf.decs;
  return (0);
}

int   dbclose (int dbhand)
{
  int   i;
  char  odh = 0x0d;

  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  for (i = 0; i < (int)files[dbhand].numflds; i++)
  {
    if (!files[dbhand].flds[i].copyflag)
      myfree (files[dbhand].flds[i].data);
  }
  myfree (files[dbhand].flds);
  if (files[dbhand].out == 1)
  {
    dos_write (files[dbhand].doshandle, &odh, sizeof (char));
    files[dbhand].out++;
  }
  if (files[dbhand].out)
  {
    dos_pos (files[dbhand].doshandle, 0L);
    dos_write (files[dbhand].doshandle, &files[dbhand].header, sizeof (struct headrec));
  }
  dos_close (files[dbhand].doshandle);
  memset (&files[dbhand], 0x0, sizeof (struct dbfile));
  return (0);
}

int   dbnew (char *filename)
{
  int   dbhand;
  char  date[9];

  for (dbhand = 0;files[dbhand].doshandle != 0 && dbhand < MAX_DB_NUM;dbhand++)
  {
    // empty loop
  }
  if (dbhand == MAX_DB_NUM)
    return (-1);
  if ((files[dbhand].doshandle = dos_open (filename, 1)) == 0)
    return (-2);
  _strdate (date);
  files[dbhand].header.id = 0x03;
  files[dbhand].header.yy = (char)atoi(&date[6]);
  files[dbhand].header.mm = (char)atoi(date);
  files[dbhand].header.dd = (char)atoi(&date[3]);
  files[dbhand].header.hdlen = 33;
  files[dbhand].header.reclen = 1;
  files[dbhand].header.nrecs = 0L;
  files[dbhand].out = 1;
  files[dbhand].numflds = 0;
  files[dbhand].flds = NULL;
  files[dbhand].recnum = 0L;
  dos_write (files[dbhand].doshandle, &files[dbhand].header, sizeof (struct headrec));
  return (dbhand);
}

int   dbaddfld (int dbhand, struct fldinfo *info)
{
  struct  dbflds  *temp;
  char            *ptr;
  int             i;
  int             fnum;

  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (-1);
  if (files[dbhand].doshandle == 0)
    return (-1);
  if (files[dbhand].out != 1)
    return (-2);
  if (files[dbhand].recnum != 0L)
    return (-3);
  files[dbhand].numflds++;
  fnum = files[dbhand].numflds - 1;
  temp = files[dbhand].flds;
  files[dbhand].header.reclen += info->length;
  files[dbhand].header.hdlen += 32;
  if ((files[dbhand].flds = mymalloc (files[dbhand].numflds * sizeof (struct dbflds))) == NULL)
    return (-4);
  if (temp != NULL)
  {
    memcpy (&files[dbhand].flds[0], temp, fnum * sizeof (struct dbflds));
    free (temp);
  }
  memset (&files[dbhand].flds[fnum].dbf, 0x0, sizeof (struct flddes));
  files[dbhand].flds[fnum].copyflag = 0;
  if ((files[dbhand].flds[fnum].data = mymalloc (info->length)) == NULL)
    return (-5);
  memset (files[dbhand].flds[fnum].dbf.fname, 0x0, 11);
  for (ptr = info->name, i = 0;*ptr && *ptr != ' ' && i < 10;ptr++, i++)
  {
    files[dbhand].flds[fnum].dbf.fname[i] = (char)toupper (*ptr);
  }
  files[dbhand].flds[fnum].dbf.ftype = (char)toupper (info->type);
  files[dbhand].flds[fnum].dbf.length = (char)info->length;
  files[dbhand].flds[fnum].dbf.decs = (char)info->decimals;
  dos_write (files[dbhand].doshandle, &files[dbhand].flds[fnum].dbf, sizeof (struct flddes));
  return (files[dbhand].numflds);
}

int   dbmodfld (int dbhand, int fldnum, char *fname)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (-1);
  if (files[dbhand].doshandle == 0)
    return (-1);
  memcpy (files[dbhand].flds[fldnum - 1].dbf.fname, fname, 10);
}

int   dbcopyfld (int n_dbhand, int o_dbhand, int o_fldnum)
{
  struct  dbflds  *temp;
  int             fnum;

  if (n_dbhand < 0 || n_dbhand > MAX_DB_NUM)
    return (-1);
  if (o_dbhand < 0 || o_dbhand > MAX_DB_NUM)
    return (-1);
  if (files[n_dbhand].doshandle == 0)
    return (-1);
  if (files[o_dbhand].doshandle == 0)
    return (-2);
  if (files[n_dbhand].out != 1)
    return (-3);
  if (files[n_dbhand].recnum != 0L)
    return (-4);
  files[n_dbhand].numflds++;
  fnum = files[n_dbhand].numflds - 1;
  temp = files[n_dbhand].flds;
  files[n_dbhand].header.reclen += files[o_dbhand].flds[o_fldnum - 1].dbf.length;
  files[n_dbhand].header.hdlen += 32;
  if ((files[n_dbhand].flds = mymalloc (files[n_dbhand].numflds * sizeof (struct dbflds))) == NULL)
    return (-5);
  if (temp != NULL)
  {
    memcpy (&files[n_dbhand].flds[0], temp, fnum * sizeof (struct dbflds));
    free (temp);
  }
  memcpy (&files[n_dbhand].flds[fnum], &files[o_dbhand].flds[o_fldnum - 1], sizeof (struct dbflds));
  files[n_dbhand].flds[fnum].copyflag = 1;
  dos_write (files[n_dbhand].doshandle, &files[n_dbhand].flds[fnum].dbf, sizeof (struct flddes));
  return (files[n_dbhand].numflds);
}

int   dbcopyall (int n_dbhand, int o_dbhand)
{
  struct  dbflds  *temp;
  int             fnum, i;

  if (n_dbhand < 0 || n_dbhand > MAX_DB_NUM)
    return (-1);
  if (o_dbhand < 0 || o_dbhand > MAX_DB_NUM)
    return (-1);
  if (files[n_dbhand].doshandle == 0)
    return (-1);
  if (files[o_dbhand].doshandle == 0)
    return (-2);
  if (files[n_dbhand].out != 1)
    return (-3);
  if (files[n_dbhand].recnum != 0L)
    return (-4);
  fnum = files[n_dbhand].numflds;
  files[n_dbhand].numflds += files[o_dbhand].numflds;
  temp = files[n_dbhand].flds;
  files[n_dbhand].header.reclen += (files[o_dbhand].header.reclen - 1);
  files[n_dbhand].header.hdlen += files[o_dbhand].numflds * 32;
  if ((files[n_dbhand].flds = mymalloc (files[n_dbhand].numflds * sizeof (struct dbflds))) == NULL)
    return (-5);
  if (temp != NULL)
  {
    memcpy (&files[n_dbhand].flds[0], temp, fnum * sizeof (struct dbflds));
    free (temp);
  }
  memcpy (&files[n_dbhand].flds[fnum], &files[o_dbhand].flds[0], files[o_dbhand].numflds * sizeof (struct dbflds));
  for (i = 0; i < (int)files[o_dbhand].numflds; i++)
  {
    files[n_dbhand].flds[fnum + i].copyflag = 1;
    dos_write (files[n_dbhand].doshandle, &files[n_dbhand].flds[fnum + i].dbf, sizeof (struct flddes));
  }
  return (files[n_dbhand].numflds);
}

int   dbputfld (int dbhand, int fldnum, char *buf)
{
  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (-1);
  if (files[dbhand].doshandle == 0)
    return (-1);
  if (fldnum > (int)files[dbhand].numflds)
    return (-2);
  while (*buf == ' ')                         // strip leading spaces
    strcpy (&buf[0], &buf[1]);
  while (buf[strlen(buf) - 1] == ' ')         // strip trailing spaces
    buf[strlen(buf) - 1] = 0;
  strcpy (str, buf);
  strupr (str);
  switch (files[dbhand].flds[fldnum - 1].dbf.ftype)
  {
    case  'D':
      if (strlen (str) != 8)
        return (-3);
      goto left_justify;
      break;

    case 'L':
      if (strlen (str) != 1)
        return (-3);
      goto left_justify;
      break;

    case 'C':
      if (strlen (str) > files[dbhand].flds[fldnum - 1].dbf.length)
        return (-3);
left_justify:
      memset (files[dbhand].flds[fldnum - 1].data, ' ', files[dbhand].flds[fldnum - 1].dbf.length);
      memcpy (files[dbhand].flds[fldnum - 1].data, str, strlen (str));
      break;

    case 'F':
    case 'N':
      memset (files[dbhand].flds[fldnum - 1].data, ' ', files[dbhand].flds[fldnum - 1].dbf.length);
      memcpy (&files[dbhand].flds[fldnum - 1].data[files[dbhand].flds[fldnum - 1].dbf.length - strlen (str)], str, strlen (str));
      break;

    default:
      return (-4);
      break;
  }
  return (0);
}

int   dbwrite (int dbhand)
{
  int   i;
  char  notdeleted = ' ';
  char  deleted = '*';
  char  odh = 0x0d;

  if (dbhand < 0 || dbhand > MAX_DB_NUM)
    return (1);
  if (files[dbhand].doshandle == 0)
    return (1);
  if (files[dbhand].out == 1)
  {
    dos_write (files[dbhand].doshandle, &odh, sizeof (char));
    files[dbhand].out++;
  }
  if (dos_write (files[dbhand].doshandle, (files[dbhand].deleteflag ? &deleted : &notdeleted), sizeof (char)) == 0)
    return (3);
  for (i = 0; i < (int)files[dbhand].numflds; i++)
  {
    if (dos_write (files[dbhand].doshandle, files[dbhand].flds[i].data, files[dbhand].flds[i].dbf.length) == 0)
      return (3);
  }
  files[dbhand].recnum++;
  if (files[dbhand].recnum > files[dbhand].header.nrecs)
    files[dbhand].header.nrecs = files[dbhand].recnum;
  files[dbhand].deleteflag = 0;     // reset deleteflag
  return (0);
}

//  locally called functions

static void  far   *mymalloc (unsigned size)
{
  unsigned        paras = (size/16) + (size%16 ? 1 : 0);
  union     REGS  regs;
  unsigned        last_bx = 0;

  regs.h.ah = 0x48;
  regs.x.bx = paras;
  intdos (&regs, &regs);
  if (regs.x.cflag)
  {
    do
    {
      last_bx = regs.x.bx;
      freemem();
      regs.h.ah = 0x48;
      regs.x.bx = paras;
      intdos (&regs, &regs);
    } while (regs.x.cflag && regs.x.bx > last_bx);
  }
  if (!regs.x.cflag)
//    return ((void far *)((unsigned long)regs.x.ax << 16));
    return ((void far *)((unsigned long)regs.x.ax * (64L * 1024L)));
  else
    return (NULL);
}

static int     myfree (void far *ptr)
{
  union   REGS  regs;
  struct  SREGS sregs;

  segread (&sregs);
//  sregs.es = (unsigned)((unsigned long)ptr >> 16);
  sregs.es = (unsigned)((unsigned long)ptr / (64L * 1024L));
  regs.h.ah = 0x49;
  intdosx (&regs, &regs, &sregs);
  if (regs.x.cflag)
    return (0);
  return (1);
}

static int   dos_open (char *filename, char output)
{
  union   REGS  regs;
  struct  SREGS sregs;

  if (output)
  {
    regs.h.ah = 0x3c;
    regs.x.cx = 0x0;
    segread (&sregs);
    sregs.ds = FP_SEG (filename);
    regs.x.dx = FP_OFF (filename);
    intdosx (&regs, &regs, &sregs);
    if (regs.x.cflag)
      return (0);
    regs.x.bx = regs.x.ax;
    regs.h.ah = 0x3e;
    intdos (&regs, &regs);
  }
  regs.h.ah = 0x3d;
  regs.h.al = 2;
  segread (&sregs);
  sregs.ds = FP_SEG (filename);
  regs.x.dx = FP_OFF (filename);
  intdosx (&regs, &regs, &sregs);
  if (regs.x.cflag)
    return (0);
  else
    return (regs.x.ax);
}

static int   dos_close (int dhandle)
{
  union REGS  regs;

  if (dhandle != 0)
  {
    regs.h.ah = 0x3e;
    regs.x.bx = dhandle;
    intdos (&regs, &regs);
    return (0);
  }
  else
    return (1);
}

static int   dos_read (int dhandle, void *buf, unsigned length)
{
  union   REGS  regs;
  struct  SREGS sregs;

  regs.h.ah = 0x3f;
  regs.x.bx = dhandle;
  regs.x.cx = length;
  segread (&sregs);
  sregs.ds = FP_SEG (buf);
  regs.x.dx = FP_OFF (buf);
  intdosx (&regs, &regs, &sregs);
  if (regs.x.cflag)
    return (0);
  else
    return (regs.x.ax);
}

static int   dos_write (int dhandle, void *buf, unsigned length)
{
  union   REGS  regs;
  struct  SREGS sregs;

  regs.h.ah = 0x40;
  regs.x.bx = dhandle;
  regs.x.cx = length;
  segread (&sregs);
  sregs.ds = FP_SEG (buf);
  regs.x.dx = FP_OFF (buf);
  intdosx (&regs, &regs, &sregs);
  if (regs.x.cflag)
    return (0);
  else
    return (regs.x.ax);
}

static unsigned  long  dos_pos (int  dhandle, unsigned long pos)
{
  union REGS  regs;

  regs.h.ah = 0x42;
  regs.h.al = 0x0;
  regs.x.bx = dhandle;
//  regs.x.cx = (unsigned)(pos >> 16);
  regs.x.cx = (unsigned)(pos / (64L * 1024L));
//  regs.x.dx = (unsigned)(pos & 0xffff);
  regs.x.dx = (unsigned)(pos % (64L * 1024L));
  intdos (&regs, &regs);
  if (regs.x.cflag)
    return (0L);
  else
//    return (((unsigned long)regs.x.dx << 16) + (unsigned long)regs.x.ax);
    return ((unsigned long)regs.x.dx * (64L * 1024L) + (unsigned long)regs.x.ax);
}

static  void  trim (char *str)
{
  char  *ptr;

  for (ptr = str; *ptr == ' ';ptr++)
  {
    // empty loop
  }
  strcpy (str, ptr);
  while (*str && str[strlen (str) - 1] == ' ')
    str[strlen(str) - 1] = 0;
}
