/*
                 This module is copyright Timothy Gregson, 1992
        It can be used only with the PC Matchmaker record linkage system
    All other use is prohibited, without written consent of copyright holder
*/

struct  fldinfo                       // structure used to return info to BASIC
{
  char            name[10];           // space padded field name
  char            type;               // type
  int             length;             // field length
  int             decimals;           // number of decimal places
};

struct  file_info
{
  long      nrecs;
  long      reclen;
  long      numflds;
  int       out;
};

int   dbinit (void);                      // init system
int   dbopen (char *filename, int mode);  // open a file
int   dballowdel (int dbhand, int flag);    // set deletedflag for a file
int   dbgetdelflag (int dbhand);          // get current delete flag
int   dbsetdelflag (int dbhand, int flag);    // set current delete flag
int   dbgetinfo (int dbhand, struct file_info *finfo);  // get file info
long  dbgetrecnum (int dbhand);         // get current record number
int   dbread (int dbhand);              // read a record
int   dbpos  (int dbhand, long recnum); // position at a record
long  dbfind (int dbhand, int fldnum, char *fld); // match a field in a record
int   dbgetfnum (int dbhand, char *fld);              // convert field name to field number
int   dbgetfld (int dbhand, int fldnum, char *buf); // get data from a field
int   dbgetfldinfo (int dbhand, int fldnum, struct fldinfo *info); // get info about field
int   dbclose (int dbhand);             // closes a dbase file, releases memory
int   dbnew (char *filename);           // starts a new db file for output
int   dbaddfld (int dbhand, struct fldinfo *info);   // add a new field to output db file
int   dbmodfld (int dbhand, int fldnum, char *fname); // change name of a field
int   dbcopyfld (int n_dbhand, int o_dbhand, int o_fldnum); // link to an existing field in an input file
int   dbcopyall (int n_dbhand, int o_dbhand);       // copy all fields
int   dbputfld (int dbhand, int fldnum, char *buf); // put data in a new field
int   dbwrite (int dbhand);                         // output a db file record
