/*
(C)Board of Trustees of the University of Illinois, 1992
Program conceived by Jeremy Atack and Fred Bateman
Developed by Mary Eschelbach Gregson
Programmed by Timothy Gregson
Funded by the National Science Foundation under grants SES-8914861 and SES-9001066
*/

#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  <dos.h>
#include  <time.h>
#include  "mem.h"
#include  "dblib.h"

#define   MAX_DB_NUM  9

struct  headrec
{
  char      id;
  char      yy;
  char      mm;
  char      dd;
  long      nrecs;
  unsigned  hdlen;
  unsigned  reclen;
  char      res1[20];
};

struct  flddes                        // format of fields in dbase file
{
  char  fname[11];                    // field name
  char  ftype;                        // field type
  char  res1[4];                      // reserved field
  char  length;                       // length of field
  char  decs;                         // number of decimals
  char  res2[14];                     // another reserved field
};

struct  dbflds
{
  struct  flddes  dbf;
  short           copyflag;
  char            *data;
};

struct  dbfile                        // structure of files in memory
{
  struct  headrec   header;           // header from dbase file
  char              out;              // true if an output file
  char              allowdel;         // true if allow deleted records through
  int               doshandle;        // dos file handle
  unsigned          numflds;          // number of fields in record
  struct  dbflds    *flds;            // pointer to first data field struct
  long              recnum;           // current record number
  char              deleteflag;       // true if current record is marked delete
};

//      internal routines

static void  far       *mymalloc (unsigned size);
static int             myfree (void far *ptr);
static int             dos_open (char *filename, char output);
static int             dos_close (int dhandle);
static int             dos_read (int dhandle, void *buf, unsigned length);
static int             dos_write (int dhandle, void *buf, unsigned length);
static unsigned  long  dos_pos (int  dhandle, unsigned long pos);
static void            trim (char *str);
