DEFINT A-Z

'$INCLUDE: 'compile.bi'
'$INCLUDE: 'dblib.bi'
'$include: 'general.bi'

declare function    blockcomp% (dummy as integer)
declare sub         writeunlink (file as integer)
declare sub         writelink (dummy as integer)
declare function    filter% (dummy as integer)
declare function    readdata% (file as integer)

copyright1$ = "(C)Board of Trustees of the University of Illinois, 1992"
copyright2$ = "Program conceived by Jeremy Atack and Fred Bateman"
copyright3$ = "Developed by Mary Eschelbach Gregson"
copyright4$ = "Programmed by Timothy Gregson"
copyright5$ = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066"

'   variables

DIM shared dbstr AS dbstring
DIM shared infofld AS fldinfo
DIM shared infofile AS fileinfo

dim shared recnum as long
dim shared rnum as long
dim shared numsel as integer
dim shared numblock as integer
dim shared numfilter as integer
dim shared nummatch as integer

dim shared filename$(1 to 2)
dim shared root$(1 to 2)
dim shared fldnum(1 to 2) as integer
dim shared eofflag(1 to 2) as integer
dim shared cstr(1 to 2) as dbstring
dim shared bstr$(1 to 2)

dim shared dathand(1 to 2) as integer          ' dBase file handles
dim shared blkhand(1 to 2) as integer
dim shared unhand(1 to 2) as integer
'dim shared tmphand(1 to 2) as integer

dim shared lnkhand as integer

print "Running Filter Program"
ercd = dbinit                   ' init dBase lib code

' parse command line

filename$(1) = getparm$
filename$(2) = getparm$
compname$ = getparm$
if (filename$(1) = "" or filename$(2) = "" or compname$ = "") then
    print "Usage: filter filenamea filenameb compname"
    end
endif

'   get root filenames of input files

for file = 1 to 2
    root$(file) = left$(filename$(file), len(filename$(file)) - 3)
next file

'   load info from compiled control file

OPEN compname$ FOR BINARY AS #1
GET 1, , numsel
GET 1, , numblock
GET 1, , numfilter
GET 1, , nummatch
DIM shared selarray AS selecttype
if (numblock <> 0) then
    DIM shared blockarray(1 to numblock) AS blocktype
    DIM shared blockdata$(1 to 3, 1 to numblock)
end if
if (numfilter <> 0) then DIM shared filterarray(1 to numfilter) as filtertype
if nummatch <> 0 then DIM shared matcharray(1 to nummatch) AS matchtype
FOR i = 1 TO numsel                 ' just eat data for select fields
    GET 1, , selarray
NEXT
FOR i = 1 TO numblock               ' read array of blocking info
    GET 1, , blockarray(i)
NEXT
FOR i = 1 TO numfilter              ' read array of filter info
    GET 1, , filterarray(i)
NEXT
FOR i = 1 TO nummatch               ' read array of matching info
    GET 1, , matcharray(i)
NEXT
CLOSE 1

' open dBase files

for file = 1 to 2
    dbstr.str = filename$(file) + CHR$(0)
    dathand(file) = dbopen(dbstr, 0)
    dbstr.str = root$(file) + "blk" + chr$(0)
    blkhand(file) = dbopen(dbstr, 0)
    dbstr.str = root$(file) + "unl" + chr$(0)
    unhand(file) = dbnew(dbstr)
    if file = 1 then
        dbstr.str = "RECNUMA" + chr$(0)
    else
        dbstr.str = "RECNUMB" + chr$(0)
    end if
    ercd = dbgetfnum (blkhand(file), dbstr)
    ercd = dbcopyfld (unhand(file), blkhand(file), ercd)
next file
dbstr.str = root$(1) + "lnk" + chr$(0)
lnkhand = dbnew (dbstr)                 ' create possible link file
dbstr.str = "RECNUMA" + chr$(0)         ' add file a record number field
ercd = dbgetfnum (blkhand(1), dbstr)
ercd = dbcopyfld (lnkhand, blkhand(1), ercd)
dbstr.str = "RECNUMB" + chr$(0)         ' add file b record number field
ercd = dbgetfnum (blkhand(2), dbstr)
ercd = dbcopyfld (lnkhand, blkhand(2), ercd)
comp = 0
for i = 1 to nummatch                   ' add fields for weight and level
    if (matcharray(i).level = 1) then
        comp = comp + 1
        infofld.ftype = "N"
        infofld.length = 11
        infofld.decimals = 6
        infofld.fname = "WEIGHT" + num$(comp, 4, "0")
        ercd = dbaddfld (lnkhand, infofld)
        infofld.ftype = "N"
        infofld.length = 2
        infofld.decimals = 0
        infofld.fname = "LEVEL" + num$(comp, 5, "0")
        ercd = dbaddfld (lnkhand, infofld)
    end if
next i
infofld.ftype = "N"                     ' add total weight field
infofld.length = 11
infofld.decimals = 6
infofld.fname = "WEIGHTOTAL"
ercd = dbaddfld (lnkhand, infofld)
for i = 1 to numblock
    dbstr.str = blockarray(i).fldnamea + chr$(0)
    blockarray(i).fldnuma = dbgetfnum (blkhand(1), dbstr)
    dbstr.str = blockarray(i).fldnameb + chr$(0)
    blockarray(i).fldnumb = dbgetfnum (blkhand(2), dbstr)
next i

ercd = readdata(1)                      ' prime both files for first record
ercd = readdata(2)

while (eofflag(1) = 0 or eofflag(2) = 0)
    comp = blockcomp (dumvar)
    if comp < 0  then                   ' file 1 < file 2
        call writeunlink (1)            ' must be no match for this record
    elseif comp > 0 then                ' file 1 > file 2
        call writeunlink (2)            ' must be no match for this record
    else                                ' file 1 = file 2
        call writelink(dumvar)          ' write out match if pass filter
    end if
wend

'   close dBase files

for file = 1 to 2
    ercd = dbclose (dathand(file))
    ercd = dbclose (blkhand(file))
    ercd = dbclose (unhand(file))
next file
ercd = dbclose (lnkhand)
end

'   FUNCTION DEFINITIONS

function blockcomp% (dummy as integer)  ' do blocking comparisons
    if (eofflag(1) <> 0) then           ' no filea data, file b >
        match = 1
    elseif (eofflag(2) <> 0) then       ' no fileb data, file a >
        match = -1
    else
        match = 0                       ' might be a match
        i = 1
        while (i <= numblock and match = 0) ' do blocking comparisons
            if blockdata$(1, i) < blockdata$(2, i) then
                match = -1                  ' not equal
            elseif blockdata$(1, i) > blockdata$(2, i) then
                match = 1                   ' not equal
            else
                match = 0                   ' equal
            end if
            i = i + 1
        wend
    end if
    blockcomp% = match                      ' return comp code
end function

sub writeunlink (file as integer)           ' write a nonlink record
    ercd = dbwrite (unhand(file))
    while (readdata(file) = 0)
        ercd = dbwrite (unhand(file))
    wend
end sub

sub writelink (dummy as integer)            ' filter files that match
    brnum1& = dbgetrecnum (blkhand(1))      ' get first recnum for each file
    brnum2& = dbgetrecnum (blkhand(2))
    ernum1& = brnum1&                       ' init last recnum for each file
    ernum2& = brnum2&
    while (readdata(1) = 0)                 ' while with block
        ernum1& = ernum1& + 1               ' increment last recnum
    wend
    while (readdata(2) = 0)                 ' same for file 2
        ernum2& = ernum2& + 1
    wend
    dim recs1 (0 to (ernum1& - brnum1&)) as integer ' allocate array
    dim recs2 (0 to (ernum2& - brnum2&)) as integer ' for matching in
    srnum2& = brnum2&                       ' start with first rec
    srnum1& = brnum1&                       ' within each files block
    while (brnum1& <= ernum1&)              ' loop thru all file a recs
        ercd = dbpos (blkhand(1), brnum1&)  ' position file pointer
        ercd = dbread (1)                   ' read current record
        brnum2& = srnum2&
        while (brnum2& <= ernum2&)          ' loop thru all file b recs
            ercd = dbpos (blkhand(2), brnum2&)  ' position file pointer
            ercd = dbread (blkhand(2))          ' read current record
            if (filter%(dumvar) = 1) then   ' see if records pass filter
                ercd = dbwrite (lnkhand)    ' yes, write linked record
                recs1(brnum1& - srnum1&) = 1    ' mark records as matched
                recs2(brnum2& - srnum2&) = 1
            end if
            brnum2& = brnum2& + 1           ' increment thru file b
        wend
        brnum1& = brnum1& + 1               ' increment thru file a
    wend
    for brnum1& = srnum1& to ernum1&        ' look for unmatched records in
        if recs1(brnum1& - srnum1&) <> 1 then   ' file a
            ercd = dbpos (blkhand(1), brnum1&)
            ercd = dbread (blkhand(1))
            ercd = dbwrite (unhand(1))
        end if
    next brnum1&
    for brnum2& = srnum2& to ernum2&        ' look for unmatched records in
        if recs2(brnum2& - srnum2&) <> 1 then   ' file b
            ercd = dbpos (blkhand(2), brnum2&)
            ercd = dbread (blkhand(2))
            ercd = dbwrite (unhand(2))
        end if
    next brnum2&
    erase recs1                             ' deallocate arrays
    erase recs2
    ercd = dbpos (blkhand(1), ernum1& + 1)  ' pos files past this block
    ercd = dbpos (blkhand(2), ernum2& + 1)
    ercd = readdata (1)                     ' setup data for next record
    ercd = readdata (2)
end sub

function filter% (dummy as integer)         ' run filter comparisons
    retval = 1
    if numfilter <> 0 then
        for file = 1 to 2                   ' point both data files to
            if file = 1 then                ' current data records
                dbstr.str = "RECNUMA" + chr$(0)
            else
                dbstr.str = "RECNUMB" + chr$(0)
            end if
            fldnum(file) = dbgetfnum (blkhand(file), dbstr)
            ercd = dbgetfld (blkhand(file), fldnum(file), dbstr)
            ercd = dbpos (dathand(file), val(ctobas$(dbstr)))
            ercd = dbread (dathand(file))
        next file
        for i = 1 to numfilter              ' run thru filter comparisons
            ercd = dbgetfld (dathand(1), filterarray(i).fldnuma, cstr(1))
            ercd = dbgetfld (dathand(2), filterarray(i).fldnumb, cstr(2))
            select case filterarray(i).ftype
                case 1              ' code to match upto X chars from name
                    x = 1
                    match = 0
                    dim matchx (1 to filterarray(i).count1) as integer
                    dim matchy (1 to filterarray(i).count1) as integer
                    lasty = 0
                    bstr$(1) = rtrim$(ltrim$(ctobas$(cstr(1))))
                    bstr$(2) = rtrim$(ltrim$(ctobas$(cstr(2))))
                    if (len (bstr$(1)) < filterarray(i).count1 or len (bstr$(2)) < filterarray(i).count1) then
                        match = filterarray(i).count1
                    end if
                    while (not(x > len(bstr$(1)) and match = 0) and match < count1)
                        while (x <= len (bstr$(1)) and match < filterarray(i).count1)
                            y = lasty + 1
                            while (y <= len(bstr$(2)) and match < filterarray(i).count1)
                                if (mid$(bstr$(1), x, 1) = mid$(bstr$(2), y, 1)) then
                                    match = match + 1
                                    matchx(match) = x
                                    matchy(match) = y
                                    lasty = y
                                    y = len(bstr$(2))
                                end if
                                y = y + 1
                            wend
                            x = x + 1
                        wend
                        if (match > 0 and match < filterarray(i).count1) then
                            match = match - 1
                            if (match = 0) then
                                x = matchx(1) + 1
                                lasty = 0
                            else
                                x = matchx (match + 1) + 1
                                lasty = matchy (match)
                            endif
                        endif
                    wend
                    erase matchx
                    erase matchy
                    if (match < filterarray(i).count1) then
                        retval = 0
                        goto filtexit
                    end if

                case 2          ' code to see if value is within a +/- range
                    if abs(val(ctobas$(cstr(1))) - val(ctobas$(cstr(2)))) > filterarray(i).count1 then
                        retval = 0
                        goto filtexit
                    end if
            end select
        next i
    end if
    filtexit: filter% = retval          ' return results of filter
end function

function readdata% (file as integer)    ' read data from a file and see if block
                                        ' has changed yet
    retval = 0
    eofflag(file) = dbread(blkhand(file))
    if (eofflag(file) = 0) then
        for i = 1 to numblock           ' read blocking data from record
            if (file = 1) then
                ercd = dbgetfld (blkhand(file), blockarray(i).fldnuma, cstr(file))
            else
                ercd = dbgetfld (blkhand(file), blockarray(i).fldnumb, cstr(file))
            end if
            blockdata$(3, i) = rtrim$(ltrim$(ctobas$ (cstr(file))))
        next i
        i = 1
        while (i <= numblock and retval = 0)    ' see if block changed
            if blockdata$(file, i) <> blockdata$(3, i) then retval = 1
            i = i + 1
        wend
        if retval = 1 then                      ' if block changed
            for i = 1 to numblock               ' set up new compare data
                blockdata$(file, i) = blockdata$(3, i)
            next i
        end if
    else
        retval = 1                              ' end of file, return 1
    end if
    readdata% = retval                          ' return result
end function
