DEFINT A-Z

'$INCLUDE: 'compile.bi'
'$INCLUDE: 'dblib.bi'
'$include: 'general.bi'
'$include: 'nysiis.bi'
'$include: 'soundex.bi'

copyright1$ = "(C)Board of Trustees of the University of Illinois, 1992"
copyright2$ = "Program conceived by Jeremy Atack and Fred Bateman"
copyright3$ = "Developed by Mary Eschelbach Gregson"
copyright4$ = "Programmed by Timothy Gregson"
copyright5$ = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066"

DIM dbstr AS dbstring
DIM infofld AS fldinfo
DIM infofile AS fileinfo

dim filename$(1 to 2)
dim root$(1 to 2)
dim level$(1 to 2)
dim fldnum(1 to 2) as integer

dim dbhand(1 to 2) as integer
dim outhand(1 to 2) as integer
dim blkhand(1 to 2) as integer

dim recnum as long
dim rnum as long
dim recp1 as long
dim recp2 as long
dim val1 as long
dim val2 as long
dim count1 as long
dim count2 as long

print "Running Freq Program"
ercd = dbinit                       ' init dBase lib

'   parse command line

filename$(1) = getparm$
filename$(2) = getparm$
compname$ = getparm$
if (filename$(1) = "" or filename$(2) = "" or compname$ = "") then
    print "Usage: freq filenamea filenameb compname"
    end
endif

'   get root filenames for both files

for file = 1 to 2
    root$(file) = left$(filename$(file), len(filename$(file)) - 3)
next file

'   load info from compiled control file

OPEN compname$ FOR BINARY AS #1
GET 1, , numsel
GET 1, , numblock
GET 1, , numfilter
GET 1, , nummatch
DIM selarray AS selecttype
DIM blockarray AS blocktype
DIM filterarray as filtertype
if (nummatch <> 0) then DIM matcharray(1 TO nummatch)  AS matchtype
FOR i = 1 TO numsel                 ' just eat data for select fields
    GET 1, , selarray
NEXT
FOR i = 1 TO numblock               ' just eat data for block fields
    GET 1, , blockarray
NEXT
FOR i = 1 TO numfilter              ' just eat data for filter fields
    GET 1, , filterarray
NEXT
FOR i = 1 TO nummatch               ' read in matching info
    GET 1, , matcharray(i)
NEXT
CLOSE 1

'

for file = 1 to 2
    dbstr.str = filename$(file) + CHR$(0)    ' open input dbase files
    dbhand(file) = dbopen(dbstr, 0)
    dbstr.str = root$(file) + "BLK" + chr$(0)
    blkhand(file) = dbopen(dbstr, 0)
    ercd = dbgetinfo (blkhand(file), infofile)
    rnumfld(file) = infofile.numflds        ' recnum is last field in record
next file

print "Initializing Frequency Tables"

'   build freq table files as dBase files
FOR i = 1 TO nummatch
    if (not (matcharray(i).mtype = 2 and matcharray(i).level <> 1)) then
        fldnum(1) = matcharray(i).fldnuma
        fldnum(2) = matcharray(i).fldnumb
        for file = 1 to 2
            dbstr.str = root$(file) + num$(i, 3, "0") + chr$(0)
            outhand(file) = dbnew(dbstr)
            ercd = dbgetfldinfo (dbhand(file), fldnum(file), infofld)
            infofld.fname = "VALUE     "
            ercd = dbaddfld (outhand(file), infofld)
            infofld.fname = "COUNT00001"
            infofld.ftype = "N"
            infofld.length = 7
            infofld.decimals = 0
            ercd = dbaddfld (outhand(file), infofld)
            ercd = dbclose (outhand(file))
        next file
    end if
next i

print

'   process each file to count frequency of matching items

for file = 1 to 2
    ercd = dbgetinfo(blkhand(file), infofile)
    LOCATE , 5, 0
    PRINT "Processing File: "; filename$(file)
    print
    while (dbread(blkhand(file)) = 0)   ' read thru block file
        ercd = dbgetfld(blkhand(file), rnumfld(file), dbstr)
        recnum = val(ctobas$(dbstr))
        ercd = dbpos (dbhand(file), recnum) ' position in data file
        ercd = dbread (dbhand(file))

' print status report

        rnum = dbgetrecnum (blkhand(file))
        IF (rnum MOD 10) = 0 THEN
            LOCATE , 5, 0
            PRINT USING "###,###"; rnum;
            PRINT " of ";
            PRINT USING "###,###"; infofile.nrecs;
        END IF

        for i = 1 to nummatch   ' loop thru matching criterion
            if (not (matcharray(i).mtype = 2 and matcharray(i).level <> 1)) then
                fldnum(1) = matcharray(i).fldnuma
                fldnum(2) = matcharray(i).fldnumb
                dbstr.str = root$(file) + num$(i, 3, "0") + chr$(0)
                outhand(file) = dbopen(dbstr, 1)
                ercd = dbgetfld (dbhand(file), fldnum(file), dbstr)
                value$ = ctobas$(dbstr)
                select case matcharray(i).mtype ' select match type
                    case 2              'NUMERIC fields
                        goto regular

                    case 3              ' exact text field
                        goto regular

                    case 10      ' exact matching fields
regular:                recnum = dbfind (outhand(file), 1, dbstr)  ' see if seen this already
                        if (recnum <> 0) then       ' yes, increment freq count
                            ercd = dbgetfld (outhand(file), 2, dbstr)
                            call inccount (dbstr)
                            ercd = dbputfld (outhand(file), 2, dbstr)
                            ercd = dbpos (outhand(file), recnum)
                            ercd = dbwrite(outhand(file))
                        else                        ' no, add new record
                            ercd = dbputfld (outhand(file), 1, dbstr)
                            dbstr.str = "1" + chr$(0)
                            ercd = dbputfld (outhand(file), 2, dbstr)
                            ercd = dbwrite (outhand(file))
                        end if

                    case 11          ' FIRSTXLETTERS field
                        if len(ctobas$(dbstr)) > matcharray(i).item1 then
                            dbstr.str = left$(dbstr.str, matcharray(i).item1) + chr$(0)
                        end if
                        goto regular

                    case 13          ' NYSIIS field
                        dbstr.str = nysiis$(ctobas$(dbstr)) + chr$(0)
                        goto regular

                    case 14          ' SOUNDEX field
                        dbstr.str = soundex$(ctobas$(dbstr)) + chr$(0)
                        goto regular

                end select
                ercd = dbclose (outhand(file))
            end if
        next i
    wend
    ercd = dbclose (dbhand(file))
    ercd = dbclose (blkhand(file))
next file

print

FOR i = 1 TO nummatch       ' sort freq files by data value
    for file = 1 to 2
        if (not (matcharray(i).mtype = 2 and matcharray(i).level <> 1)) then
            sf$ = root$(file) + num$(i, 3, "0")
            cmdstr$ = "quiksort " + sf$ + " " + sf$ + " DB VALUE >nul:"
            print "Sorting File: "; sf$
            shell cmdstr$
        end if

' if numeric type, must count range values now

        if matcharray(i).mtype = 2 and matcharray(i).level = 1 then
            level1$(file) = root$(file) + num$(i, 3, "0") + chr$(0) ' set filename
        elseif matcharray(i).mtype = 2 and matcharray(i).level <> 1 then
            print "Post Processing Numeric Table: "; root$(file) + num$(i, 3, "0")
            dbstr.str = root$(file) + num$(i, 3, "0") + chr$(0)
            outhand(file) = dbnew (dbstr)
            dbstr.str = level1$(1) + chr$(0)
            dbhand(file) = dbopen (dbstr, 0)
            ercd = dbcopyall (outhand(file), dbhand(file))
            while (dbread(dbhand(file)) = 0)
                ercd = dbwrite (outhand(file))
            wend
            ercd = dbclose (dbhand(file))
            ercd = dbclose (outhand(file))
            dbstr.str = root$(file) + num$(i, 3, "0") + chr$(0)
            outhand(file) = dbopen (dbstr, 1)
            dbstr.str = level1$(file) + chr$(0)
            dbhand(file) = dbopen (dbstr, 0)
            recnum = 1
            while (dbread(outhand(file)) = 0)
                ercd = dbgetfld (outhand(file), 1, dbstr)
                valout = val(ctobas$(dbstr))
                ercd = dbpos (dbhand(file), recnum)
                fileeof = dbread (dbhand(file))
                ercd = dbgetfld (dbhand(file), 1, dbstr)

' skip records less than minus range

                while (fileeof = 0 and val(ctobas$(dbstr)) < valout - matcharray(i).item2)
                    fileeof = dbread (dbhand(file))
                    ercd = dbgetfld (dbhand(file), 1, dbstr)
                wend

' at beginning of range vals

                recnum = dbgetrecnum(dbhand(file))
                count = 0

' count values in range until greater than plus range

                while (fileeof = 0 and val(ctobas$(dbstr)) <= valout + matcharray(i).item1)
                    ercd = dbgetfld (dbhand(file), 2, dbstr)
                    count = count + val(ctobas$(dbstr))
                    fileeof = dbread (dbhand(file))
                    ercd = dbgetfld (dbhand(file), 1, dbstr)
                wend

' got count, write to output file

                ercd = dbpos (outhand(file), dbgetrecnum(outhand(file)))
                dbstr.str = ltrim$(rtrim$(str$(count)))
                ercd = dbputfld (outhand(file), 2, dbstr)
                ercd = dbwrite (outhand(file))
            wend
            ercd = dbclose (outhand(file))
            ercd = dbclose (dbhand(file))
            print
        endif
    next file
next i
end
