/*
                 This module is copyright Timothy Gregson, 1992
        It can be used only with the PC Matchmaker record linkage system
    All other use is prohibited, without written consent of copyright holder
*/

#define   Normal(key) (!key.stat.shft && !key.stat.ctrl && !key.stat.alt)
#define   Shift(key)  (key.stat.shft && !key.stat.ctrl && !key.stat.alt)
#define   Control(key) (!key.stat.shft && key.stat.ctrl && !key.stat.alt)
#define   Alt(key) (!key.stat.shft && !key.stat.ctrl && key.stat.alt)

#define   make_scrl   0x46
#define   break_scrl  0xc6
#define   make_num    0x45
#define   break_num   0xc5
#define   make_caps   0x3a
#define   break_caps  0xba
#define   e0_code     0xe0
#define   exit_code   0x60          // bogus code used by application programs
#define   e1_code     0xe1
#define   quit_code   0x61          // another bogus code used by apps
#define   make_ctrl   0x1d
#define   break_ctrl  0x9d
#define   make_alt    0x38
#define   break_alt   0xb8
#define   make_lshft  0x2a
#define   break_lshft 0xaa
#define   make_rshft  0x36
#define   break_rshft 0xb6
#define   make_a      0x1e
#define   break_a     0x9e
#define   make_b      0x30
#define   break_b     0xb0
#define   make_c      0x2e
#define   break_c     0xae
#define   make_d      0x20
#define   break_d     0xa0
#define   make_e      0x12
#define   break_e     0x92
#define   make_f      0x21
#define   break_f     0xa1
#define   make_g      0x22
#define   break_g     0xa2
#define   make_h      0x23
#define   break_h     0xa3
#define   make_i      0x17
#define   break_i     0x97
#define   make_j      0x24
#define   break_j     0xa4
#define   make_k      0x25
#define   break_k     0xa5
#define   make_l      0x26
#define   break_l     0xa6
#define   make_m      0x32
#define   break_m     0xb2
#define   make_n      0x31
#define   break_n     0xb1
#define   make_o      0x18
#define   break_o     0x98
#define   make_p      0x19
#define   break_p     0x99
#define   make_q      0x10
#define   break_q     0x90
#define   make_r      0x13
#define   break_r     0x93
#define   make_s      0x1f
#define   break_s     0x9f
#define   make_t      0x14
#define   break_t     0x94
#define   make_u      0x16
#define   break_u     0x96
#define   make_v      0x2f
#define   break_v     0xaf
#define   make_w      0x11
#define   break_w     0x91
#define   make_x      0x2d
#define   break_x     0xad
#define   make_y      0x15
#define   break_y     0x95
#define   make_z      0x2c
#define   break_z     0xac
#define   make_1      0x02
#define   break_1     0x82
#define   make_2      0x03
#define   break_2     0x83
#define   make_3      0x04
#define   break_3     0x84
#define   make_4      0x05
#define   break_4     0x85
#define   make_5      0x06
#define   break_5     0x86
#define   make_6      0x07
#define   break_6     0x87
#define   make_7      0x08
#define   break_7     0x88
#define   make_8      0x09
#define   break_8     0x89
#define   make_9      0x0a
#define   break_9     0x8a
#define   make_0      0x0b
#define   break_0     0x8b
#define   make_n1     0x4f
#define   break_n1    0xcf
#define   make_n2     0x50
#define   break_n2    0xd0
#define   make_n3     0x51
#define   break_n3    0xd1
#define   make_n4     0x4b
#define   break_n4    0xcb
#define   make_n5     0x4c
#define   break_n5    0xcc
#define   make_n6     0x4d
#define   break_n6    0xcd
#define   make_n7     0x47
#define   break_n7    0xc7
#define   make_n8     0x48
#define   break_n8    0xc8
#define   make_n9     0x49
#define   break_n9    0xc9
#define   make_n0     0x52
#define   break_n0    0xd2
#define   make_nperiod 0x53
#define   break_nperiod 0xd3
#define   make_f1     0x3b
#define   break_f1    0xbb
#define   make_f2     0x3c
#define   break_f2    0xbc
#define   make_f3     0x3d
#define   break_f3    0xbd
#define   make_f4     0x3e
#define   break_f4    0xbe
#define   make_f5     0x3f
#define   break_f5    0xbf
#define   make_f6     0x40
#define   break_f6    0xc0
#define   make_f7     0x41
#define   break_f7    0xc1
#define   make_f8     0x42
#define   break_f8    0xc2
#define   make_f9     0x43
#define   break_f9    0xc3
#define   make_f10    0x44
#define   break_f10   0xc4
#define   make_f11    0x57
#define   break_f11   0xd7
#define   make_f12    0x58
#define   break_f12   0xd8
#define   make_tab    0x0f
#define   break_tab   0x8f
#define   make_bs     0x0e
#define   break_bs    0x8e
#define   make_ret    0x1c
#define   break_ret   0x9c
#define   make_esc    0x01
#define   break_esc   0x81
#define   make_ins    0x52
#define   break_ins   0xd2
#define   make_del    0x53
#define   break_del   0xd3
#define   make_home   0x47
#define   break_home  0xc7
#define   make_end    0x4f
#define   break_end   0xcf
#define   make_pgup   0x49
#define   break_pgup  0xc9
#define   make_pgdn   0x51
#define   break_pgdn  0xd1
#define   make_up     0x48
#define   break_up    0xc8
#define   make_dn     0x50
#define   break_dn    0xd0
#define   make_rt     0x4d
#define   break_rt    0xcd
#define   make_lt     0x4b
#define   break_lt    0xcb
#define   make_cn     0x4c
#define   break_cn    0xcc
#define   make_sp     0x39
#define   break_sp    0xb9
#define   make_dash   0x0c
#define   break_dash  0x8c
#define   make_equal  0x0d
#define   break_equal 0x8d
#define   make_lsquar 0x1a
#define   break_lsquar 0x9a
#define   make_rsquar 0x1b
#define   break_rsquar 0x9b
#define   make_scolon 0x27
#define   break_scolon 0xa7
#define   make_squote 0x28
#define   break_squote 0xa8
#define   make_comma  0x33
#define   break_comma 0xb3
#define   make_period 0x34
#define   break_period 0xb4
#define   make_slash  0x35
#define   break_slash 0xb5
#define   make_btick  0x29
#define   break_btick 0xa9
#define   make_bslash 0x2b
#define   break_bslash 0xab
#define   make_gplus  0x4e
#define   break_gplus 0xce
#define   make_gminus 0x4a
#define   break_gminus 0xca
#define   make_gastrik 0x37
#define   break_gastrik 0xb7
#define   make_anykey   0x56
#define   break_anykey  0xd6

extern  int   no_togl;
extern  int   no_hidn;
extern  int   no_shft;
extern  int   no_break;
extern  unsigned  char  scan_tab[89];
extern  unsigned  char  shift_scan_tab[89];
extern  unsigned  char  caps_scan_tab[89];
extern  unsigned  char  caps_shift_scan_tab[89];

struct  key_status
{
    unsigned    int   caps    :   1,
                      num     :   1,
                      scrl    :   1,
                      hidn    :   1,
                      empty   :   1,
                      shft    :   1,
                      ctrl    :   1,
                      alt     :   1;
};

struct  key_data
{
    struct  key_status  stat;
    unsigned  char      code;
};

struct  key_proc
{
  unsigned  char  code;
  int             (*proc) (struct key_data key);
};

        int       install_int9 (void);
        void      uninstall_int9 (void);
struct  key_data  get_q (void);
        int       unget_q (struct key_data);
struct  key_data  wait_get_q (void);
        char      ascii_get_q (void);
        char      wait_ascii_get_q (void);
        char      conv_ascii (struct key_data);
struct  key_data  peek_q (void);
        void      flush_q (void);
        int       check_q (void);
        void      put_q (int);
        int       add_hot_key (char code, int (*proc)(struct key_data key));
        void      remove_hot_key (char code, int (*proc)(struct key_data key));
        int       add_warm_key (char code, int (*proc)(struct key_data key));
        void      remove_warm_key (char code, int (*proc)(struct key_data key));
