        DEFINT A-Z

'$include: 'nysiis.bi'

rem (C)Board of Trustees of the University of Illinois, 1992
rem Program conceived by Jeremy Atack and Fred Bateman
rem Developed by Mary Eschelbach Gregson
rem Programmed by Timothy Gregson
rem Funded by the National Science Foundation under grants SES-8914861 and SES-9001066

FUNCTION nysiis$ (in$)
name$ = ltrim$(rtrim$(in$))
outstr$ = ""
curr = 1
'
'   change starting letters for conformity
'
'   step 1 - page 24 - "...SRS record linkage system"
'
IF LEFT$(name$, 3) = "MAC" THEN
    MID$(name$, 1, 3) = "MCC"
ELSEIF LEFT$(name$, 2) = "KN" THEN
    MID$(name$, 1, 2) = "NN"
ELSEIF LEFT$(name$, 1) = "K" THEN
    MID$(name$, 1, 1) = "C"
ELSEIF LEFT$(name$, 2) = "PH" THEN
    MID$(name$, 1, 2) = "FF"
ELSEIF LEFT$(name$, 2) = "PF" THEN
    MID$(name$, 1, 2) = "FF"
ELSEIF LEFT$(name$, 3) = "SCH" THEN
    MID$(name$, 1, 3) = "SSS"
ELSEIF LEFT$(name$, 2) = "WR" THEN
    MID$(name$, 1, 2) = "RR"
ELSEIF LEFT$(name$, 2) = "RH" THEN
    MID$(name$, 1, 2) = "RR"
ELSEIF LEFT$(name$, 2) = "DG" THEN
    MID$(name$, 1, 2) = "GG"
ELSE
    tmp$ = LEFT$(name$, 1)
    IF tmp$ = "A" OR tmp$ = "E" OR tmp$ = "I" OR tmp$ = "O" OR tmp$ = "U" THEN
        MID$(name$, 1, 1) = "A"
    END IF
END IF
'
'   drop terminal 'S' or 'Z'
'
'   step 2
'
IF RIGHT$(name$, 1) = "S" THEN
    name$ = left$(name$, len(name$) - 1)
ELSEIF RIGHT$(name$, 1) = "Z" THEN
    name$ = left$(name$, len(name$) - 1)
END IF
'
'   change ending letters for conformity
'
'   step 3
'
tmp$ = RIGHT$(name$, 2)
IF tmp$ = "EE" THEN
    name$ = left$(name$, len(name$) - 2) + "Y"
ELSEIF tmp$ = "IE" THEN
    name$ = left$(name$, len(name$) - 2) + "Y"
ELSEIF tmp$ = "YE" THEN
    name$ = left$(name$, len(name$) - 2) + "Y"
'
'   modified by t. gregson to handle names like 'schmidt' or 'schmit'
'
'   original was change to 'D ' now is change to 'T '
'
ELSEIF tmp$ = "DT" THEN
    name$ = left$(name$, len(name$) - 2) + "T"
ELSEIF tmp$ = "RT" OR tmp$ = "RD" THEN
    name$ = left$(name$, len(name$) - 2) + "D"
ELSEIF tmp$ = "NT" OR tmp$ = "ND" THEN
    name$ = left$(name$, len(name$) - 2) + "N"
ELSEIF tmp$ = "IX" THEN
    MID$(name$, LEN(name$) - 1, 3) = "ICK"
ELSEIF tmp$ = "EX" THEN
    MID$(name$, LEN(name$) - 1, 3) = "ECK"
'
'   also says something about 'JR' & 'SR' going to error table 2 - what is this
'
END IF
'
'       remove any terminal spaces that we may have added
'
name$ = ltrim$(rtrim$(name$))
'
'   output first char of name as first char of code string
'
'   step 4
'
outstr$ = LEFT$(name$, 1)
'
'   beginning of program loop to evaluate chars in middle of name
'       starting with second character
'
'   step 5
'
curr = 2
WHILE (curr <= LEN(name$))
'
'   evaluate current char and process accordingly
'
'   step 6
'
    IF MID$(name$, curr, 2) = "EV" THEN
        MID$(name$, curr, 2) = "AF"
    ELSE
        SELECT CASE MID$(name$, curr, 1)
            CASE "A", "E", "I", "O", "U"
                MID$(name$, curr, 1) = "A"
            CASE "Y"
                IF curr <> LEN(name$) THEN
                    MID$(name$, curr, 1) = "A"
                END IF
            CASE "Q"
                MID$(name$, curr, 1) = "G"
            CASE "Z"
                MID$(name$, curr, 1) = "S"
            CASE "M"
                MID$(name$, curr, 1) = "N"
            CASE "K"
                IF MID$(name$, curr, 2) = "KN" THEN
                    MID$(name$, curr, 1) = "N"
                ELSE
                    MID$(name$, curr, 1) = "C"
                END IF
            CASE "S"
                IF MID$(name$, curr, 3) = "SCH" THEN
                    IF curr + 2 = LEN(name$) THEN
                        MID$(name$, curr, 3) = "SSA"
                    ELSE
                        MID$(name$, curr, 3) = "SSS"
                    END IF
                ELSEIF MID$(name$, curr, 2) = "SH" THEN
                    IF curr + 1 = LEN(name$) THEN
                        MID$(name$, curr, 2) = "SA"
                    ELSE
                        MID$(name$, curr, 2) = "SS"
                    END IF
                END IF
            CASE "P"
                IF MID$(name$, curr, 2) = "PH" THEN
                    MID$(name$, curr, 2) = "FF"
                END IF
            CASE "G"
                IF MID$(name$, curr, 3) = "GHT" THEN
                    MID$(name$, curr, 3) = "TTT"
                END IF
            CASE "D"
                IF MID$(name$, curr, 2) = "DG" THEN
                    MID$(name$, curr, 2) = "GG"
                END IF
            CASE "W"
                IF MID$(name$, curr, 2) = "WR" THEN
                    MID$(name$, curr, 2) = "RR"
                ELSEIF right$(outstr$, 1) = "A" then
                    MID$(name$, curr, 1) = "A"
                END IF
            CASE "H"
                tmp$ = MID$(name$, curr - 1, 1)
                tmp1$ = MID$(name$, curr + 1, 1)
                IF tmp$ <> "A" OR (tmp1$ <> "A" AND tmp1$ <> "E" AND tmp1$ <> "I" AND tmp1$ <> "O" AND tmp1$ <> "U") THEN
                    MID$(name$, curr, 1) = right$(outstr$, 1)
                END IF
        END SELECT
    END IF
'
'   if current char not equal to last char - output it
'           increment pointer
'
'   step 7
'
'       added by T. Gregson - 2-5-91
'               drop any embedded spaces
'
'
    IF MID$(name$, curr, 1) <> RIGHT$(outstr$, 1) and mid$(name$, curr, 1) <> " " THEN
        outstr$ = outstr$ + MID$(name$, curr, 1)
    END IF
    curr = curr + 1
WEND
'
'   check for ending 'S' - remove it
'
'   step 8
'
IF RIGHT$(outstr$, 1) = "S" THEN
    outstr$ = LEFT$(outstr$, LEN(outstr$) - 1)
END IF
'
'   check for ending 'AY' - replace with 'Y'
'
'   step 9
'
IF RIGHT$(outstr$, 2) = "AY" THEN
    outstr$ = LEFT$(outstr$, LEN(outstr$) - 2) + "Y"
END IF
'
'   check for ending 'AL' - replace with 'L'
'
'   added by m. gregson to handle endings like 'le' or 'el'
'
IF RIGHT$(outstr$, 2) = "AL" THEN
    outstr$ = LEFT$(outstr$, LEN(outstr$) - 2) + "L"
END IF
'
'   check for ending 'A' - remove it
'
'   step 10
'
IF RIGHT$(outstr$, 1) = "A" THEN
    outstr$ = LEFT$(outstr$, LEN(outstr$) - 1)
END IF
'
'   there is also a step eleven to replace a space or 'A' with original
'   first character - but the 'A' was put here intentionally and there
'   should be no way to have a leading space in final run
nysiis$ = outstr$
END FUNCTION

