DEFINT A-Z

'$INCLUDE: 'compile.bi'
'$INCLUDE: 'dblib.bi'
'$include: 'general.bi'
'$include: 'nysiis.bi'
'$include: 'soundex.bi'

copyright1$ = "(C)Board of Trustees of the University of Illinois, 1992"
copyright2$ = "Program conceived by Jeremy Atack and Fred Bateman"
copyright3$ = "Developed by Mary Eschelbach Gregson"
copyright4$ = "Programmed by Timothy Gregson"
copyright5$ = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066"

DIM dbstr AS dbstring
DIM info AS fldinfo
DIM infofile AS fileinfo

dim recnum as long

dim filename$(1 to 2)
dim dbhand(1 to 2) as integer
dim dbout(1 to 2) as integer
dim numsel(1 to 2) as integer
dim fldnum(1 to 2) as integer

print "Running Preproc Program"
ercd = dbinit               ' init dBase lib

'   parse command line

filename$(1) = getparm$
filename$(2) = getparm$
compname$ = getparm$
if (filename$(1) = "" or filename$(2) = "" or compname$ = "") then
    print "Usage: preproc filenamea filenameb compname"
    end
endif

'   read compiled control file info

OPEN compname$ FOR BINARY AS #1
GET 1, , numsel
GET 1, , numblock
GET 1, , numfilter
GET 1, , nummatch
if numsel <> 0 then DIM selarray(1 TO numsel)  AS selecttype
if numblock <> 0 then DIM blockarray(1 TO numblock)  AS blocktype
if numblock <> 0 then DIM blockflds(1 TO numblock + 1, 1 TO 2) AS INTEGER
numsel(1) = 0
numsel(2) = 0
FOR i = 1 TO numsel
    GET 1, , selarray(i)
    if selarray(i).fldnuma <> 0 then numsel(1) = numsel(1) + 1
    if selarray(i).fldnumb <> 0 then numsel(2) = numsel(2) + 1
NEXT
FOR i = 1 TO numblock
    GET 1, , blockarray(i)
NEXT
CLOSE 1

for x = 1 to 2      ' open data files and create block files
    dbstr.str = filename$(x) + chr$(0)
    dbhand(x) = dbopen(dbstr, 0)
    dbstr.str = left$(filename$(x), len(filename$(x)) - 3) + "BLK" + chr$(0)
    dbout(x) = dbnew(dbstr)
next x

' go thru blocking criterion to add fields to blocking files

FOR i = 1 TO numblock
    SELECT CASE blockarray(i).btype
        CASE 1, 2, 4                 'NYSIIS, SOUNDEX, & FIRSTXLETTERS blocking
            ercd = dbgetfldinfo(dbhand(1), blockarray(i).fldnuma, info)
            info.fname = STRING$(10, " ")
            x = 1
            WHILE (MID$(blockarray(i).fldnamea, x, 1) <> CHR$(0))
                MID$(info.fname, x, 1) = MID$(blockarray(i).fldnamea, x, 1)
                x = x + 1
            WEND
            IF (blockarray(i).btype = 4) THEN info.length = blockarray(i).length
            blockflds(i, 1) = dbaddfld(dbout(1), info)
            ercd = dbgetfldinfo(dbhand(2), blockarray(i).fldnumb, info)
            info.fname = STRING$(10, " ")
            x = 1
            WHILE (MID$(blockarray(i).fldnameb, x, 1) <> CHR$(0))
                MID$(info.fname, x, 1) = MID$(blockarray(i).fldnameb, x, 1)
                x = x + 1
            WEND
            IF (blockarray(i).btype = 4) THEN info.length = blockarray(i).length
            blockflds(i, 2) = dbaddfld(dbout(2), info)

        CASE 3                  'field COPY blocking
            blockflds(i, 1) = dbcopyfld(dbout(1), dbhand(1), blockarray(i).fldnuma)
            blockflds(i, 2) = dbcopyfld(dbout(2), dbhand(2), blockarray(i).fldnumb)

        CASE ELSE               'exception
            PRINT "Unknown blocking type in compiled file: "; blockarray(i).btype
            STOP

    END SELECT
NEXT
info.fname = "RECNUMA   "       ' add record number field
info.ftype = "N"
info.length = 6
info.decimals = 0
blockflds(numblock + 1, 1) = dbaddfld(dbout(1), info)
info.fname = "RECNUMB   "
blockflds(numblock + 1, 2) = dbaddfld(dbout(2), info)

for file = 1 to 2
    ercd = dbgetinfo(dbhand(file), infofile)
    LOCATE , 5, 0
    PRINT "Processing File: "; filename$(file)
    print
    WHILE ((dbread(dbhand(file))) = 0)      ' loop thru file
        recnum = dbgetrecnum (dbhand(file))

'   print status report
        IF (recnum MOD 10) = 0 THEN
            LOCATE , 5, 0
            PRINT USING "###,###"; recnum;
            PRINT " of ";
            PRINT USING "###,###"; infofile.nrecs;
        END IF

        IF numsel(file) = 0 THEN    ' any selection criterions
            selected = 1            ' no, record auto selected
        ELSE
            selected = 0            ' yes, init selected flag
            i = 1
            WHILE i <= numsel
                fldnum(1) = selarray(i).fldnuma
                fldnum(2) = selarray(i).fldnumb
                IF fldnum(file) <> 0 THEN
                    ercd = dbgetfld(dbhand(file), fldnum(file), dbstr)
                    cmp1$ = RTRIM$(LTRIM$(ctobas$(dbstr)))
                    if file = 1 then
                        dbstr.str = selarray(i).string1
                    else
                        dbstr.str = selarray(i).string2
                    end if
                    cmp2$ = RTRIM$(LTRIM$(ctobas$(dbstr)))
                    if left$(cmp2$, 1) = "&" then
                        andflag = 1
                        andselect = selected
                        selected = 0
                        cmp2$ = right$(cmp2$, len(cmp2$) - 1)
                    end if
                    if left$(cmp2$, 1) = "<" then
                        if val(cmp1$) < val(right$(cmp2$, len(cmp2$) - 1)) then selected = 1
                    elseif left$(cmp2$, 1) = ">" then
                        if val(cmp1$) > val(right$(cmp2$, len(cmp2$) - 1)) then selected = 1
                    else
                        IF cmp1$ = cmp2$ THEN selected = 1
                    end if
                    if andflag = 1 and andselect = 0 then
                        selected = 0
                    end if
                    andflag = 0
                    andselect = 0
                END IF
                i = i + 1
            WEND
        END IF
        if selected = 1 then
            FOR i = 1 TO numblock
                fldnum(1) = blockarray(i).fldnuma
                fldnum(2) = blockarray(i).fldnumb
                SELECT CASE blockarray(i).btype
                    CASE 1
                        ercd = dbgetfld(dbhand(file), fldnum(file), dbstr)
                        name$ = ctobas$(dbstr)
                        dbstr.str = nysiis$(name$) + CHR$(0)
                        ercd = dbputfld(dbout(file), blockflds(i, file), dbstr)

                    CASE 2
                        ercd = dbgetfld(dbhand(file), fldnum(file), dbstr)
                        name$ = ctobas$(dbstr)
                        dbstr.str = soundex$(name$) + CHR$(0)
                        ercd = dbputfld(dbout(file), blockflds(i, file), dbstr)

    '               CASE 3          ' nothing to do for a copy field - handled automatically by dblib

                    CASE 4
                        ercd = dbgetfld(dbhand(file), fldnum(file), dbstr)
                        MID$(dbstr.str, blockarray(i).length + 1, 1) = CHR$(0)
                        ercd = dbputfld(dbout(file), blockflds(i, file), dbstr)
                END SELECT
            NEXT
            dbstr.str = (STR$(recnum)) + CHR$(0)
            ercd = dbputfld(dbout(file), blockflds(numblock + 1, file), dbstr)
            ercd = dbwrite(dbout(file))
        end if
    WEND
next file
for file = 1 to 2
    ercd = dbclose(dbhand(file))
    ercd = dbclose(dbout(file))
next file
sort$ = "quiksort "
sort$ = sort$ + left$(filename$(1), len(filename$(1)) - 3) + "BLK "
sort$ = sort$ + left$(filename$(1), len(filename$(1)) - 3) + "BLK DB ("
for i = numblock to 1 step -1
    temp$ = ltrim$(rtrim$(left$(blockarray(i).fldnamea, 10)))
    sort$ = sort$ + temp$ + " "
next i
sort$ = sort$ + "RECNUMA)"
print sort$
shell sort$
sort$ = "quiksort "
sort$ = sort$ + left$(filename$(2), len(filename$(2)) - 3) + "BLK "
sort$ = sort$ + left$(filename$(2), len(filename$(2)) - 3) + "BLK DB ("
for i = numblock to 1 step -1
    temp$ = ltrim$(rtrim$(left$(blockarray(i).fldnameb, 10)))
    sort$ = sort$ + temp$ + " "
next i
sort$ = sort$ + "RECNUMB)"
print sort$
shell sort$
END
