/*
(C)Board of Trustees of the University of Illinois, 1992
Program conceived by Jeremy Atack and Fred Bateman
Developed by Mary Eschelbach Gregson
Programmed by Timothy Gregson
Funded by the National Science Foundation under grants SES-8914861 and SES-9001066
*/

#define       sbcol             0x31
#define       stcol             0x13
#define       mbcol             0x25
#define       mtcol             0x25
#define       ebcol             0x12
#define       etcol             0x12
#define       mwidth            30
#define       mheight           7

struct  type_list
{
  char  type_name[15];
  char  message[78];
};

//  structure for singly linked list of items
//
//  record types
//    1 - "   flda fldb  vala  valb"
//    2 - "   type flda  fldb  nflda nfldb [length]"
//    3 - "   type flda  fldb  [val]"
//    4 - "     subtype [length]"
//

struct  list_item
{
  char  rec_type;
  char  fldname[2][11];     // flda, fldb
  char  data[2][26];        // vala, valb, val, nflda, nfldb
  char  type[14];           // type
  char  length[4];          // length
  struct  list_item *next;  // pointer to next entry
};
