DEFINT  A-Z

'$include: 'soundex.bi'

rem (C)Board of Trustees of the University of Illinois, 1992
rem Program conceived by Jeremy Atack and Fred Bateman
rem Developed by Mary Eschelbach Gregson
rem Programmed by Timothy Gregson
rem Funded by the National Science Foundation under grants SES-8914861 and SES-9001066

FUNCTION soundex$ (in$)
    name$ = LTRIM$(RTRIM$(in$))
    outstr$ = LEFT$(name$, 1)
    SELECT CASE outstr$
        CASE "A", "E", "H", "I", "O", "U", "W", "Y" ' these don't translate
            pcode = 0

        CASE "B", "F", "P", "V"                     ' these are 1's
            pcode = 1

        CASE "C", "G", "J", "K", "Q", "S", "X", "Z" ' these are 2's
            pcode = 2

        CASE "D", "T"                               ' these are 3's
            pcode = 3

        CASE "L"                                    ' these are 4's
            pcode = 4

        CASE "M", "N"                               ' these are 5's
            pcode = 5

        CASE "R"                                    ' these are 6's
            pcode = 6
    END SELECT

    curr = 2
    WHILE (curr <= LEN(name$) and LEN(outstr$) < 4)
        SELECT CASE MID$(name$, curr, 1)
            CASE "A", "E", "H", "I", "O", "U", "W", "Y" ' these don't translate
                code = 0

            CASE "B", "F", "P", "V"                     ' these are 1's
                code = 1

            CASE "C", "G", "J", "K", "Q", "S", "X", "Z" ' these are 2's
                code = 2

            CASE "D", "T"                               ' these are 3's
                code = 3

            CASE "L"                                    ' these are 4's
                code = 4

            CASE "M", "N"                               ' these are 5's
                code = 5

            CASE "R"                                    ' these are 6's
                code = 6
        END SELECT
        IF (pcode <> code and code > 0) THEN
            outstr$ = outstr$ + LTRIM$(RTRIM$(STR$(code)))
        END IF
        pcode = code
        curr = curr + 1
    WEND
    WHILE (LEN(outstr$) < 4)
        outstr$ = outstr$ + "0"
    WEND
    soundex$ = outstr$
END FUNCTION
