#include  <stdio.h>
#include  <string.h>
#include  <stdlib.h>
#include  <malloc.h>

#include  "dblib.h"

static char copyright1[] = "(C)Board of Trustees of the University of Illinois, 1992";
static char copyright2[] = "Program conceived by Jeremy Atack and Fred Bateman";
static char copyright3[] = "Developed by Mary Eschelbach Gregson";
static char copyright4[] = "Programmed by Timothy Gregson";
static char copyright5[] = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066";

struct  tblfmt
{
  double  weight;
  short   used;
  long    lrec;
  short   stupid_filler;
};

void  main (int argc, char **argv);

void  main (int argc, char **argv)
{
/*
  struct  tblfmt      *tbla, *tblb;
*/
  int                     lnk, filea, fileb, def, ind;
  struct  file_info       data_a, data_b, data_l;
  struct  tblfmt  _huge   *tbla;
  struct  tblfmt  _huge   *tblb;
  char                    buf[50];
  double                  weight;
  double                  cutoff;
  long                    recnuma;
  long                    recnumb;
  int                     eof;

  dbinit ();
  if (argc != 5)
  {
    fprintf (stderr, "Usage: split filea fileb lnkfile cutoff\n");
    exit (1);
  }

  if ((filea = dbopen (argv[1], 1)) < 0)
  {
    fprintf (stderr, "Unable to open file a: %s\n", argv[1]);
    exit (2);
  }
  if ((fileb = dbopen (argv[2], 1)) < 0)
  {
    fprintf (stderr, "Unable to open file b: %s\n", argv[2]);
    exit (3);
  }
  dbgetinfo (filea, &data_a);
  dbgetinfo (fileb, &data_b);
  dbclose (filea);
  dbclose (fileb);

  if ((lnk = dbopen (argv[3], 0)) < 0)
  {
    fprintf (stderr, "Unable to open link file: %s\n", argv[3]);
    exit (4);
  }
  cutoff = atof (argv[4]);
  dbgetinfo (lnk, &data_l);
/*
  if ((tbla = malloc ((data_a.nrecs + 1) * sizeof (struct tblfmt))) == NULL)
  {
    fprintf (stderr, "Unable to allocate table a\n");
    exit (5);
  }
  if ((tblb = malloc ((data_b.nrecs + 1) * sizeof (struct tblfmt))) == NULL)
  {
    fprintf (stderr, "Unable to allocate table b\n");
    exit (6);
  }
  memset (tbla, 0x0, sizeof (struct tblfmt) * (data_a.nrecs + 1));
  memset (tblb, 0x0, sizeof (struct tblfmt) * (data_b.nrecs + 1));
*/
  if ((tbla = halloc (data_a.nrecs + 1L, sizeof(struct tblfmt))) == NULL)
  {
    fprintf (stderr, "Unable to allocate table a\n");
    exit (5);
  }
  if ((tblb = halloc (data_b.nrecs + 1L, sizeof(struct tblfmt))) == NULL)
  {
    fprintf (stderr, "Unable to allocate table a\n");
    exit (6);
  }
  eof = dbread (lnk);
  dbgetfld (lnk, (int)data_l.numflds, buf);
  weight = atof(buf);
  while (!eof && weight >= cutoff)
  {
    dbgetfld (lnk, 1, buf);
    recnuma = atol(buf);
    dbgetfld (lnk, 2, buf);
    recnumb = atol(buf);
    if (!tbla[recnuma].used && !tblb[recnumb].used)
    {
      tbla[recnuma].used++;
      tblb[recnumb].used++;
      tbla[recnuma].lrec = recnumb;
      tblb[recnumb].lrec = recnuma;
      tbla[recnuma].weight = weight;
      tblb[recnumb].weight = weight;
    }
    else
    {
      if (tbla[recnuma].weight == weight || tblb[recnumb].weight == weight)
      {
        tbla[recnuma].used = 2;       /* mark both entries as 'over' used so no one else will match them */
        tblb[recnumb].used = 2;
      }
      else
      {
        if (!tbla[recnuma].used)
          tbla[recnuma].used = 2;
        if (!tbla[recnumb].used)
          tblb[recnumb].used = 2;
      }
    }
    eof = dbread (lnk);
    dbgetfld (lnk, (int)data_l.numflds, buf);
    weight = atof(buf);
  }
  dbpos (lnk, 1L);
  strcpy (buf, argv[1]);    // get filename A
  strcpy (&buf[strlen(buf) - 3], "def");
  def = dbnew (buf);
  dbcopyall (def, lnk);
  strcpy (&buf[strlen(buf) - 3], "ind");
  ind = dbnew (buf);
  dbcopyall (ind, lnk);
  while (dbread(lnk) == 0)
  {
    dbgetfld (lnk, (int)data_l.numflds, buf);
    weight = atof(buf);
    dbgetfld (lnk, 1, buf);
    recnuma = atol(buf);
    dbgetfld (lnk, 2, buf);
    recnumb = atol(buf);
    if (tbla[recnuma].used == 1 && tbla[recnuma].lrec == recnumb)
      dbwrite (def);
    else
      dbwrite (ind);
  }
  dbclose (lnk);
  dbclose (ind);
  dbclose (def);
/*
  free (tbla);
  free (tblb);
*/
  hfree (tbla);
  hfree (tblb);
}
