DEFINT  A-Z

'$include: 'compile.bi'
'$include: 'dblib.bi'
'$include: 'general.bi'

copyright1$ = "(C)Board of Trustees of the University of Illinois, 1992"
copyright2$ = "Program conceived by Jeremy Atack and Fred Bateman"
copyright3$ = "Developed by Mary Eschelbach Gregson"
copyright4$ = "Programmed by Timothy Gregson"
copyright5$ = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066"

dim shared dbstr as dbstring
dim shared infofld as fldinfo
dim shared infofile as fileinfo

dim shared filename$(1 to 2)
dim shared root$(1 to 2)

dim shared lnkhand as integer

print "Running Tweight Program"
ercd = dbinit
filename$(1) = getparm$
filename$(2) = getparm$
compname$ = getparm$
cut$ = getparm$
print filename$(1)
print filename$(2)
print compname$
print cut$
if (filename$(1) = "" or filename$(2) = "" or compname$ = "" or cut$ = "") then
    print "Usage: tweight filenamea filenameb compname cutoff"
    end
endif

cutoff# = val(cut$)

trnname$ = left$(filename$(1), len(filename$(1)) - 3) + "TRN"

for file = 1 to 2
    root$(file) = left$(filename$(file), len(filename$(file)) - 3)
next file

'   load info from compiled control file

OPEN compname$ FOR BINARY AS #1
GET 1, , numsel
GET 1, , numblock
GET 1, , numfilter
GET 1, , nummatch
DIM shared selarray AS selecttype
DIM shared blockarray AS blocktype
DIM shared filterarray as filtertype
if (nummatch <> 0) then
    DIM shared matcharray(1 to nummatch) AS matchtype
    DIM shared trans#(1 to nummatch)
    DIM shared otrans#(1 to nummatch)
    open trnname$ FOR BINARY AS #2
end if
FOR i = 1 TO numsel                 ' just eat data for select fields
    GET 1, , selarray
NEXT
FOR i = 1 TO numblock
    GET 1, , blockarray
NEXT
FOR i = 1 TO numfilter
    GET 1, , filterarray
NEXT
numcomp = 0
FOR i = 1 TO nummatch               ' just eat data for match fields
    GET 1, , matcharray(i)
    get 2, , otrans#(i)
    if matcharray(i).level = 1 then numcomp = numcomp + 1
NEXT
CLOSE 1
if (nummatch <> 0) then close 2

dbstr.str = root$(1) + "lnk" + chr$(0)
lnkhand = dbopen (dbstr, 0)
ercd = dbgetinfo (lnkhand, infofile)

dim dataarray (1 to infofile.nrecs, 1 to numcomp) as integer

rec = 0
while (dbread(lnkhand) = 0)
    ercd = dbgetfld (lnkhand, (numcomp * 2) + 3, dbstr)
    if cutoff# <= val(ctobas$(dbstr)) then
        rec = rec + 1
        for i = 1 to numcomp
            ercd = dbgetfld (lnkhand, (i * 2) + 2, dbstr)
            dataarray(rec, i) = val(ctobas$(dbstr))
        next i
    end if
wend
totrecs = rec
ercd = dbclose (lnkhand)

comp = 0
for match = 1 to nummatch
    if matcharray(match).level = 1 then
        comp = comp + 1
    end if
    count = 0
    for rec = 1 to totrecs
        if dataarray(rec, comp) <= matcharray(match).level  and dataarray(rec, comp) <> 0 then
            count = count + 1
        end if
    next rec
    trans#(match) = ((count * 1.#)/totrecs)
    print otrans#(match), trans#(match)
next match
open trnname$ FOR BINARY AS #1
for i = 1 to nummatch
    put #1, , trans#(i)
next i
close #1
