DEFINT  A-Z

'$include: 'compile.bi'
'$include: 'dblib.bi'
'$include: 'general.bi'

declare function sumit# (j as integer, instr$)
declare function matchit (i as integer, string1$, string2$, flg as integer)
declare sub loadfreq (i as integer, string1$, string2$)

copyright1$ = "(C)Board of Trustees of the University of Illinois, 1992"
copyright2$ = "Program conceived by Jeremy Atack and Fred Bateman"
copyright3$ = "Developed by Mary Eschelbach Gregson"
copyright4$ = "Programmed by Timothy Gregson"
copyright5$ = "Funded by the National Science Foundation under grants SES-8914861 and SES-9001066"

dim shared dbstr as dbstring
dim shared infofld as fldinfo
dim shared infofile as fileinfo

dim shared filename$(1 to 2)
dim shared root$(1 to 2)
dim shared fldnum(1 to 2) as integer
dim shared cstr(1 to 2) as dbstring
dim shared bstr$(1 to 2)
dim shared numrec(1 to 2) as long
dim shared frq(1 to 2) as long
dim shared value(1 to 2) as integer

dim shared dathand(1 to 2) as integer
dim shared frqhand(1 to 2) as integer
dim shared tmphand(1 to 2) as integer

dim shared lnkhand as integer

print "Running Weight Program"
ercd = dbinit               ' init dBase lib

'   parse command line

filename$(1) = getparm$
filename$(2) = getparm$
compname$ = getparm$
if (filename$(1) = "" or filename$(2) = "" or compname$ = "") then
    print "Usage: weight filenamea filenameb compname"
    end
endif

' gen transmission weight filename
trnname$ = left$(filename$(1), len(filename$(1)) - 3) + "TRN"

for file = 1 to 2
    root$(file) = left$(filename$(file), len(filename$(file)) - 3)
next file

'   load info from compiled control file

OPEN compname$ FOR BINARY AS #1
GET 1, , numsel
GET 1, , numblock
GET 1, , numfilter
GET 1, , nummatch
DIM shared selarray AS selecttype
DIM shared blockarray AS blocktype
DIM shared filterarray as filtertype
if (nummatch <> 0) then
    DIM shared matcharray(1 to nummatch) AS matchtype
    DIM shared trans(1 to nummatch) as double
    open trnname$ FOR BINARY AS #2
end if
FOR i = 1 TO numsel                 ' just eat data for select fields
    GET 1, , selarray
NEXT
FOR i = 1 TO numblock
    GET 1, , blockarray
NEXT
FOR i = 1 TO numfilter
    GET 1, , filterarray
NEXT
FOR i = 1 TO nummatch               ' just eat data for match fields
    GET 1, , matcharray(i)
    get 2, , trans(i)               ' read transmission weights
NEXT
CLOSE 1
if (nummatch <> 0) then close 2

for file = 1 to 2       ' get number of records in each block file
    dbstr.str = root$(file) + "BLK" + chr$(0)
    dathand(file) = dbopen(dbstr, 0)
    ercd = dbgetinfo (dathand(file), infofile)
    numrec(file) = infofile.nrecs
    ercd = dbclose (dathand(file))
    dbstr.str = filename$(file) + chr$(0)   ' open data file
    dathand(file) = dbopen(dbstr, 0)
next file
dbstr.str = root$(1) + "lnk" + chr$(0)      ' open possible link file
lnkhand = dbopen (dbstr, 1)

while (dbread (lnkhand) = 0)            ' loop thru link file records
    for file = 1 to 2                   ' position each data file
        ercd = dbgetfld (lnkhand, file, dbstr)
        rec(file) = val(ctobas$(dbstr))
        ercd = dbpos (dathand(file), rec(file))
        ercd = dbread (dathand(file))
    next file
    i = 1
    comp = 0                            ' init compare and weight vars
    totweight# = 0.#
    while (i <= nummatch)
        if (matcharray(i).level = 1) then
            weight# = 0.#                                  ' init weight
            match = 0
            subcomp = 0
            comp = comp + 1
        end if
        if (match = 0) then
            fldnum(1) = matcharray(i).fldnuma
            fldnum(2) = matcharray(i).fldnumb
            for file = 1 to 2
                ercd = dbgetfld (dathand(file), fldnum(file), cstr(file))
                bstr$(file) = rtrim$(ltrim$(ctobas$(cstr(file))))
            next file
            if len(bstr$(1)) <> 0 and len(bstr$(2)) <> 0 then
                match = matchit (i, bstr$(1), bstr$(2), 0)
                subcomp = matcharray(i).level
            else
                match = 0
                subcomp = 0
                weight# = 0
            end if
            badop = 0
            if match = 1  or i = nummatch or matcharray(i + 1).level = 1 then
                if (subcomp <> 0) then
                    if match = 1 and subcomp = 1 then
                        weight# = log2 (trans(i) ^ 2) + log2 ((numrec(2) * 1.#) / frq(2))
                    elseif match = 1 then
                        if matcharray(subcomp).mtype = 13 then
                            weight# = 0
                        else
                            sum# = sumit#(i, bstr$(1))
                            temptrans# = trans(i) ^ 2 - trans(i - 1) ^ 2
                            if (temptrans# < 0) then
                                print "Temporary transmission weight difference less than zero"
                                badop = 1
                            end if
                            tempval1# = frq(1)/(numrec(1) * 1.#)
                            tempval2# = tempval1# * (frq(2)/(numrec(2) * 1.#))
                            if (tempval2# < sum#) then
                                print "Temporary level value less than previous levels sum"
                                print "Temporary level value: ", tempval2#
                                print "Previous level sum: ", sum#
                                badop = 1
                            end if
                            if (badop <> 0) then
                                print
                                print "File A record: ", dbgetrecnum(dathand(1))
                                print "File B record: ", dbgetrecnum(dathand(2))
                                print "Match Level: ", i
                                print "Match Sub Level: ", matcharray(i).level
                                print "Match Type: ", matcharray(i).mtype
                                print "Field Num File A: ", matcharray(i).fldnuma
                                print "Field Num File B: ", matcharray(i).fldnumb
                                print "Extra data 1: ", matcharray(i).item1
                                print "Extra data 2: ", matcharray(i).item2
                                print
                            end if
                            weight# = log2 (temptrans#) + log2 (tempval1# / (tempval2# - sum#))
                        end if
                    else                        ' computation if not matched
                        call loadfreq ((i - matcharray(i).level) + 1, bstr$(1), bstr$(2))
                        weight# = log2(trans((i - matcharray(i).level) + 1) ^ 2) + log2 ((frq(1) * frq(2) * 1.0#)/(numrec(1) * numrec(2) * 1.0#))
                        subcomp = 0
                    end if
                end if
                dbstr.str = dbltodb$ (weight#, 11, 6) + chr$(0)
                ercd = dbputfld (lnkhand, 1 + (comp * 2), dbstr)
                dbstr.str = rtrim$(ltrim$(str$(subcomp))) + chr$(0)
                ercd = dbputfld (lnkhand, 2 + (comp * 2), dbstr)
                totweight# = totweight# + weight#
            end if
        end if
        i = i + 1
    wend
    dbstr.str = dbltodb$ (totweight#, 11, 6) + chr$(0)
    ercd = dbputfld (lnkhand, 3 + (comp * 2), dbstr)
    ercd = dbpos (lnkhand, dbgetrecnum (lnkhand))
    ercd = dbwrite (lnkhand)
wend
end

function sumit# (i as integer, instr$)
    sum# = 0.#
    for file = 1 to 2
        if matcharray(i).mtype <> 2 then
            dbstr.str = root$(file) + num$(i - 1, 3, "0") + chr$(0)
        else
            dbstr.str = root$(file) + num$((i - matcharray(i).level) + 1, 3, "0") + chr$(0)
        end if
        tmphand(file) = dbopen(dbstr, 0)
    next file
    while (dbread (tmphand(1)) = 0)
        ercd = dbgetfld (tmphand(1), 1, dbstr)
        tmp$ = ltrim$(rtrim$(ctobas$(dbstr)))
        if (matchit (i, instr$, tmp$, 1) = 1) then
            if (dbfind(tmphand(2), 1, dbstr)) then
                ercd  = dbgetfld (tmphand(1), 2, dbstr)
                value1 = val(ctobas$(dbstr))
                ercd = dbgetfld (tmphand(2), 2, dbstr)
                sum# = sum# + ((value1/(numrec(1) * 1.0#)) * (val(ctobas$(dbstr))/(numrec(2) * 1.0#)))
            end if
        end if
    wend
    for file = 1 to 2
        ercd = dbclose (tmphand(file))
    next file
    sumit# = sum#
end function

function matchit (i as integer, string1$, string2$, flg as integer)
    temp1$ = string1$
    temp2$ = string2$
    select case matcharray(i).mtype
        case 2                                      ' numeric match type
            value1 = val(temp1$)
            value2 = val(temp2$)

        case 11                                     ' name matches on first X leters
            if len (temp1$) > matcharray(i).item1 then
                temp1$ = left$(temp1$, matcharray(i).item1)
            end if
            if len (temp2$) > matcharray(i).item1 then
                temp2$ = left$(temp2$, matcharray(i).item1)
            end if

        case 13, 14                                 ' name matches on NYSIIS code
            temp1$ = ""
            temp2$ = ""

    end select
    if flg = 0 then call loadfreq (i, temp1$, temp2$)   ' only do this if calling from main
    if (matcharray(i).mtype = 2) then                   ' handle numeric comp different
        if (value1 + matcharray(i).item1 >= value2 and value1 <= value2) or (value1 - matcharray(i).item2 <= value2 and value1 >= value2) then
            matchit = 1
        end if
    else                                                ' other comps are exact
        if (temp1$ = temp2$) then
            matchit = 1
        end if
    end if
end function

sub loadfreq (i as integer, temp1$, temp2$)
    for file = 1 to 2
        dbstr.str = root$(file) + num$(i, 3, "0") + chr$(0)
        frqhand(file) = dbopen (dbstr, 0)
    next file

    dbstr.str = temp1$ + chr$(0)
    ercd = dbfind (frqhand(1), 1, dbstr)
    ercd = dbgetfld (frqhand(1), 2, dbstr)
    frq(1) = val (ctobas$(dbstr))

    dbstr.str = temp1$ + chr$(0)
    ercd = dbfind (frqhand(2), 1, dbstr)
    ercd = dbgetfld (frqhand(2), 2, dbstr)
    frq(2) = val (ctobas$(dbstr))

    ercd = dbclose(frqhand(1))
    ercd = dbclose(frqhand(2))
end sub
