/*
                 This module is copyright Timothy Gregson, 1992
        It can be used only with the PC Matchmaker record linkage system
    All other use is prohibited, without written consent of copyright holder
*/

#define   SINGLE    256
#define   DOUBLE    257

typedef struct  window_type
{
  short           row1,
                  col1,
                  row2,
                  col2,
                  used,
                  row,
                  col;
  char            battr,
                  tattr,
                  shadow,
                  displayed;
  unsigned        border;
  struct  scr_ch  *save;
} WINDOW;

#define wposat(w, r, c)   {\
                            w->row = r;\
                            w->col = c;\
                          }

extern  char  window_wrap;          // word wrap flag on window output
extern  char  window_strip;         // strip leading spaces on window output

WINDOW  *wopen (short row1, short col1, short row2, short col2, char battr, char tattr, unsigned border, char shadow, char display);
void    wclose (WINDOW **wind);
void    wdisp (WINDOW *wind);
void    wremove (WINDOW *wind);
void    wclear (WINDOW *wind);
void    wprintat (WINDOW *wind, short wrow, short wcol, char *buf);
void    wcprintat (WINDOW *wind, short wrow, short wcol, char attr, char *buf);
void    wprintbat (WINDOW *wind, short wrow, short wcol, char *buf, int count);
void    wcprintbat (WINDOW *wind, short wrow, short wcol, char attr, char *buf, int count);
void    wprintfat (WINDOW *wind, short wrow, short wcol, char *str, ...);
void    wcprintfat (WINDOW *wind, short wrow, short wcol, char attr, char *str, ...);
void    wvprintfat (WINDOW *wind, short wrow, short wcol, char *str, va_list arg_list);
void    wvcprintfat (WINDOW *wind, short wrow, short wcol, char attr, char *str, va_list arg_list);
void    wprintcen (WINDOW *wind, short wrow, char *buf);
void    wcprintcen (WINDOW *wind, short wrow, char attr, char *buf);
void    wprintbcen (WINDOW *wind, short wrow, char *buf, int count);
void    wcprintbcen (WINDOW *wind, short wrow, char attr, char *buf, int count);
void    wprintfcen (WINDOW *wind, short wrow, char *str, ...);
void    wcprintfcen (WINDOW *wind, short wrow, char attr, char *str, ...);
void    wvprintfcen (WINDOW *wind, short wrow, char *str, va_list arg_list);
void    wvcprintfcen (WINDOW *wind, short wrow, char attr, char *str, va_list arg_list);
void    wprint (WINDOW *wind, char *buf);
void    wcprint (WINDOW *wind, char attr, char *buf);
void    wprintb (WINDOW *wind, char *buf, int count);
void    wcprintb (WINDOW *wind, char attr, char *buf, int count);
void    wprintf (WINDOW *wind, char *str, ...);
void    wcprintf (WINDOW *wind, char attr, char *str, ...);
void    wvprintf (WINDOW *wind, char *str, va_list arg_list);
void    wvcprintf (WINDOW *wind, char attr, char *str, va_list arg_list);
void    wheader (WINDOW *wind, char *str, ...);
void    wcheader (WINDOW *wind, char attr, char *str, ...);
void    wfooter (WINDOW *wind, char *str, ...);
void    wcfooter (WINDOW *wind, char attr, char *str, ...);
void    wfill (WINDOW *wind, short wrow1, short wcol1, short wrol2, short wcol2, char ch, char attr);
void    wfillat (WINDOW *wind, short wrow1, short wcol1, short wrol2, short wcol2, char attr);
void    wfillch (WINDOW *wind, short wrow1, short wcol1, short wrol2, short wcol2, char ch);
void    wchatat (WINDOW *wind, short wrow, short wcol, char ch, char attr);
void    wcharat (WINDOW *wind, short wrow, short wcol, char ch);
void    wattrat (WINDOW *wind, short wrow, short wcol, char attr);
void    whilite (WINDOW *wind, short wrow, short wcol, short width);
